module mReset(clk,Q,reset);
	input clk,Q;
	output reset;
	reg [15:0] rcnt;
	reg resout;
	wire cntup;
	
	assign cntup=(rcnt!=16'h8000) ? 1'b1 : 1'b0;
	assign reset=~rcnt[15];
	//Power On Reset (=100ms)
	always @(posedge clk) begin
		begin
			if( Q & cntup) begin
				rcnt=rcnt+1'b1;
			end
		end
	end
endmodule

module mOsc1s(reset,clk,Qin,Qout);
	input reset,clk,Qin;
	output Qout;
	reg [10:0] cnt;
	
	assign Qout=((cnt==11'b11111111111) & Qin & ~reset) ? 1'b1 : 1'b0;
	
	always @(posedge clk or posedge reset) begin
		if(reset) begin
			cnt<=11'h0;
		end else begin
			if(Qin) begin
				cnt<=cnt+1'b1;
			end
		end
	end
endmodule
		
module mOscDiv(reset,clk,Qin,Qout);
	input reset,clk,Qin;
	output Qout;
	reg cnt;
	
	assign Qout=(cnt & Qin & ~reset);
	
	always @(posedge clk or posedge reset) begin
		if(reset) begin
			cnt<=1'h0;
		end else begin
			if(Qin) begin
				cnt<=~cnt;
			end
		end
	end
endmodule

module mStep(reset,clk,Qin,sw,Qout);
	input reset,clk,Qin,sw;
	output Qout;
	reg dsw;
	reg rQout;
	wire step;
	assign Qout=rQout & Qin & ~reset;
	assign step=dsw & ~sw;
	always @(posedge clk or posedge reset) begin
		if(reset) begin
			dsw<=1'b1;
		end else begin
			dsw<=sw;
		end
	end

	always @(posedge clk or posedge reset) begin
		if(reset) begin
			rQout<=1'b0;
		end else begin
			if(Qin) begin
				rQout<=1'b0;
			end else if(step) begin
				rQout <=1'b1;
			end 
		end
	end

endmodule
