;=======================================================================
;   Test Program for PIC16F508 Emulator
;   GP0-GP2 LED
;=======================================================================

	list      p=12F508
	#include <p12F508.inc>

	__CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC


;====== Variables ======================================================
WORK		EQU		0x08
LED		EQU		0x09

	ORG     	0x1FF             ; Reset Vector

;====== Program start ===================================================
	ORG		0x000             ; Start Address
	GOTO	start

;====== Initialize  =====================================================
init
	;Initialize GPIO
	MOVLW	0x08             ; GP3͓
	TRIS	GPIO
	MOVLW	0xC7             ;vXP[=1/256
	OPTION
	CLRF	GPIO
	CLRF	LED
	RETLW	0

;====== wait_sec  =======================================================
wait_sec
	MOVLW	0x0d
	MOVWF	WORK
wait_1
	MOVLW	1
	MOVWF	TMR0
wait_2
	MOVF	TMR0,W
	BTFSS	STATUS,Z
	GOTO	wait_2
	DECFSZ	WORK,F
	GOTO	wait_1
	RETLW	0


;====== Main Program  ===================================================
start	
	CALL	init
main_1
	COMF	LED,W
	MOVWF	GPIO
	CALL	wait_sec
	BTFSC	GPIO,3
	GOTO	main_2
	INCF	LED,W
	goto	main_3
main_2
	DECF	LED,W
main_3
	ANDLW	0x07
	MOVWF	LED
	GOTO	main_1
	END

