module mPWM(reset,clk,datin,cntout,pwmout);
	input reset,clk;
	input [7:0] datin;
	output [7:0] cntout;
	output pwmout;
	reg [7:0] val;
	reg [7:0] cnt;
	reg pwm;
	wire cntend;
	
	assign cntout=cnt;
	assign cntend=(cnt==8'hfe) ? 1'b1 : 1'b0;
	assign pwmout=pwm;
	
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			cnt<=8'h0;
		end else begin
			if(cntend) begin
				cnt<=8'h0;
			end else begin
				cnt<=cnt+1'b1;
			end
		end
	end
	
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			val<=8'h0;
		end else begin
			if(cntend) begin
				val<=datin;
			end
		end
	end
	
	always@(posedge clk or posedge reset) begin
		if(reset) begin
			pwm<=1'b0;
		end else begin
			if(cnt<val)
				pwm<=1'b1;
			else
				pwm<=1'b0;
		end
	end
endmodule
