`timescale 1 ps / 1 ps

module tb_M508Emu();

    parameter CLK_PERIOD = 20 ; 	// 50MHz Duty50% (toggle every 10ns passed)

	wire wEXTCLK;         // clock to M508Emu
	wire wEXTRST;         // Reset to M508Emu
	wire [7:0] wGPIO;     // GPIO to/from M508Emu
	wire [7:0] wLED;      // LED control signal from M508Emu
	wire [3:0] wKEY;      // Switch signal to M508Emu
	wire wSAWOUT;         // Saw Wave Output from M508Emu
	
	
	reg rEXTCLK;

    initial begin
       rEXTCLK = 1'b0 ;
       forever #(CLK_PERIOD/2) rEXTCLK = ~rEXTCLK;
    end
    
    assign wEXTCLK = rEXTCLK;

	reg [3:0] rKEY;
    initial begin
       rKEY = 4'b0000 ;
    end
	assign wKEY = rKEY;

	reg rEXTRST;
    initial begin
       rEXTRST = 1'b1 ;
    end
	assign wEXTRST = rEXTRST;

	M508Emu m508emu(
       .EXTCLK(wEXTCLK),
       .EXTRST(wEXTRST),
       .GPIO(wGPIO),
       .LED(wLED),
       .KEY(wKEY),
       .SAWOUT(wSAWOUT)
    );
    
    
    initial begin
       #(50*CLK_PERIOD) ;
       rEXTRST = 1'b0;
       #(100*CLK_PERIOD) ;
       $stop;
    end
	
endmodule
