module mFlashMem(adr,dat);
	input [8:0] adr;
	output [11:0] dat;
	reg [11:0] romdat;
	assign dat=romdat;
	always @(adr) begin
		case (adr)
        12'h000 : romdat=12'h0A12;    //          GOTO    start
                                      //  init
        12'h001 : romdat=12'h0C08;    //          MOVLW   0x08             ; GP3͓
        12'h002 : romdat=12'h0006;    //          TRIS    GPIO
        12'h003 : romdat=12'h0066;    //          CLRF    GPIO
        12'h004 : romdat=12'h006A;    //          CLRF    CNT
        12'h005 : romdat=12'h0068;    //          CLRF    VAL
        12'h006 : romdat=12'h0069;    //          CLRF    NVAL
        12'h007 : romdat=12'h0800;    //          RETLW   0
                                      //  PwmOut
        12'h008 : romdat=12'h0208;    //          MOVF    VAL,W
        12'h009 : romdat=12'h00A9;    //          SUBWF   NVAL,F
        12'h00A : romdat=12'h02A8;    //          INCF    VAL,1
        12'h00B : romdat=12'h0506;    //          BSF             GPIO,0
                                      //  Pwm1
        12'h00C : romdat=12'h02E8;    //          DECFSZ  VAL,f
        12'h00D : romdat=12'h0A0C;    //          GOTO    Pwm1    
        12'h00E : romdat=12'h0406;    //          BCF             GPIO,0
                                      //  Pwm2
        12'h00F : romdat=12'h02E9;    //          DECFSZ  NVAL,f
        12'h010 : romdat=12'h0A0F;    //          GOTO    Pwm2
        12'h011 : romdat=12'h0800;    //          RETLW   0
                                      //  start   
        12'h012 : romdat=12'h0901;    //          CALL    init
                                      //  main_1
        12'h013 : romdat=12'h0908;    //          CALL    PwmOut
        12'h014 : romdat=12'h02AA;    //          INCF    CNT,F
        12'h015 : romdat=12'h020A;    //          MOVF    CNT,W
        12'h016 : romdat=12'h0028;    //          MOVWF   VAL
        12'h017 : romdat=12'h0A13;    //          GOTO    main_1
      default : romdat=12'h0fff;
		endcase
	end
endmodule


